Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.servlet.handler
Class AbstractHandlerExceptionResolver

    java.lang.Object
      org.springframework.web.servlet.handler.AbstractHandlerExceptionResolver

All Implemented Interfaces:
  Ordered, HandlerExceptionResolver

Direct Known Subclasses:
  AbstractHandlerMethodExceptionResolver, AnnotationMethodHandlerExceptionResolver, DefaultHandlerExceptionResolver, ResponseStatusExceptionResolver, SimpleMappingExceptionResolver

    public abstract class AbstractHandlerExceptionResolver

extends Object
implements HandlerExceptionResolver, Ordered

Abstract base class for `HandlerExceptionResolver` implementations.

Provides a set of mapped handlers that the resolver should map to, and the `Ordered` implementation.

Since:
  3.0
Author:
  Arjen Poutsma, Juergen Hoeller

Field Summary
`protected Log` | `logger` Logger available to subclasses

Fields inherited from interface org.springframework.core.Ordered
`HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

Constructor Summary
`AbstractHandlerExceptionResolver()`

Method Summary
`protected String` | `buildLogMessage(Exception ex, HttpServletRequest request)` Build a log message for the given exception, occured during processing the given request.
`protected abstract ModelAndView` | `doResolveException(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex)` Actually resolve the given exception that got thrown during on handler execution, returning a ModelAndView that represents a specific error page if appropriate.
`int` | `getOrder()` Return the order value of this object, with a higher value meaning greater in terms of sorting.
`protected void` | `logException(Exception ex, HttpServletRequest request)` Log the given exception at warn level, provided that warn logging has been activated through the `"warnLogCategory"` property.
`protected void` | `prepareResponse(Exception ex, HttpServletResponse response)` Prepare the response for the exceptional case.
`protected void` | `preventCaching(HttpServletResponse response)` Prevents the response from being cached, through setting corresponding HTTP headers.
`ModelAndView` | `resolveException(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex)` Checks whether this resolver is supposed to apply (i.e.
`void` | `setMappedHandlerClasses(Class[] mappedHandlerClasses)` Specify the set of classes that this exception resolver should apply to.
`void` | `setMappedHandlers(Set mappedHandlers)` Specify the set of handlers that this exception resolver should apply to.
`void` | `setOrder(int order)`
`void` | `setPreventResponseCaching(boolean preventResponseCaching)` Specify whether to prevent HTTP response caching for any view resolved by this HandlerExceptionResolver.
`void` | `setWarnLogCategory(String loggerName)` Set the log category for warn logging.
`protected boolean` | `shouldApplyTo(HttpServletRequest request, Object handler)` Check whether this resolver is supposed to apply to the given handler.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final Log logger

  Logger available to subclasses

Constructor Detail

### AbstractHandlerExceptionResolver

    public AbstractHandlerExceptionResolver()

Method Detail

### setOrder

    public void setOrder(int order)

### getOrder

    public int getOrder()

  Description copied from interface: `Ordered`
  Return the order value of this object, with a higher value meaning greater in terms of sorting.

  Normally starting with 0, with `Integer.MAX_VALUE` indicating the greatest value. Same order values will result in arbitrary positions for the affected objects.

  Higher values can be interpreted as lower priority. As a consequence, the object with the lowest value has highest priority (somewhat analogous to Servlet "load-on-startup" values).

  Specified by:
    `getOrder` in interface `Ordered`
  Returns:
    the order value

### setMappedHandlers

    public void setMappedHandlers(Set mappedHandlers)

  Specify the set of handlers that this exception resolver should apply to. The exception mappings and the default error view will only apply to the specified handlers.

  If no handlers and handler classes are set, the exception mappings and the default error view will apply to all handlers. This means that a specified default error view will be used as fallback for all exceptions; any further HandlerExceptionResolvers in the chain will be ignored in this case.

### setMappedHandlerClasses

    public void setMappedHandlerClasses(Class[] mappedHandlerClasses)

  Specify the set of classes that this exception resolver should apply to. The exception mappings and the default error view will only apply to handlers of the specified type; the specified types may be interfaces and superclasses of handlers as well.

  If no handlers and handler classes are set, the exception mappings and the default error view will apply to all handlers. This means that a specified default error view will be used as fallback for all exceptions; any further HandlerExceptionResolvers in the chain will be ignored in this case.

### setWarnLogCategory

    public void setWarnLogCategory(String loggerName)

  Set the log category for warn logging. The name will be passed to the underlying logger implementation through Commons Logging, getting interpreted as log category according to the logger's configuration.

  Default is no warn logging. Specify this setting to activate warn logging into a specific category. Alternatively, override the `logException(java.lang.Exception, javax.servlet.http.HttpServletRequest)` method for custom logging.

  See Also:
    `LogFactory.getLog(String)`, `Logger.getLogger(String)`, `Logger.getLogger(String)`

### setPreventResponseCaching

    public void setPreventResponseCaching(boolean preventResponseCaching)

  Specify whether to prevent HTTP response caching for any view resolved by this HandlerExceptionResolver.

  Default is "false". Switch this to "true" in order to automatically generate HTTP response headers that suppress response caching.

### resolveException

    public ModelAndView resolveException(HttpServletRequest request,
                                         HttpServletResponse response,
                                         Object handler,
                                         Exception ex)

  Checks whether this resolver is supposed to apply (i.e. the handler matches in case of "mappedHandlers" having been specified), then delegates to the `doResolveException(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse, java.lang.Object, java.lang.Exception)` template method.

  Specified by:
    `resolveException` in interface `HandlerExceptionResolver`
  Parameters:
    `request` - current HTTP request
    `response` - current HTTP response
    `handler` - the executed handler, or `null` if none chosen at the time of the exception (for example, if multipart resolution failed)
    `ex` - the exception that got thrown during handler execution
  Returns:
    a corresponding ModelAndView to forward to, or `null` for default processing

### shouldApplyTo

    protected boolean shouldApplyTo(HttpServletRequest request,
                                    Object handler)

  Check whether this resolver is supposed to apply to the given handler.

  The default implementation checks against the specified mapped handlers and handler classes, if any.

  Parameters:
    `request` - current HTTP request
    `handler` - the executed handler, or `null` if none chosen at the time of the exception (for example, if multipart resolution failed)
  Returns:
    whether this resolved should proceed with resolving the exception for the given request and handler
  See Also:
    `setMappedHandlers(java.util.Set)`, `setMappedHandlerClasses(java.lang.Class[])`

### logException

    protected void logException(Exception ex,
                                HttpServletRequest request)

  Log the given exception at warn level, provided that warn logging has been activated through the `"warnLogCategory"` property.

  Calls `buildLogMessage(java.lang.Exception, javax.servlet.http.HttpServletRequest)` in order to determine the concrete message to log. Always passes the full exception to the logger.

  Parameters:
    `ex` - the exception that got thrown during handler execution
    `request` - current HTTP request (useful for obtaining metadata)
  See Also:
    `setWarnLogCategory(java.lang.String)`, `buildLogMessage(java.lang.Exception, javax.servlet.http.HttpServletRequest)`, `Log.warn(Object, Throwable)`

### buildLogMessage

    protected String buildLogMessage(Exception ex,
                                     HttpServletRequest request)

  Build a log message for the given exception, occured during processing the given request.

  Parameters:
    `ex` - the exception that got thrown during handler execution
    `request` - current HTTP request (useful for obtaining metadata)
  Returns:
    the log message to use

### prepareResponse

    protected void prepareResponse(Exception ex,
                                   HttpServletResponse response)

  Prepare the response for the exceptional case.

  The default implementation prevents the response from being cached, if the `"preventResponseCaching"` property has been set to "true".

  Parameters:
    `ex` - the exception that got thrown during handler execution
    `response` - current HTTP response
  See Also:
    `preventCaching(javax.servlet.http.HttpServletResponse)`

### preventCaching

    protected void preventCaching(HttpServletResponse response)

  Prevents the response from being cached, through setting corresponding HTTP headers. See `http://www.mnot.net/cache_docs`.

  Parameters:
    `response` - current HTTP response

### doResolveException

    protected abstract ModelAndView doResolveException(HttpServletRequest request,
                                                       HttpServletResponse response,
                                                       Object handler,
                                                       Exception ex)

  Actually resolve the given exception that got thrown during on handler execution, returning a ModelAndView that represents a specific error page if appropriate.

  May be overridden in subclasses, in order to apply specific exception checks. Note that this template method will be invoked after checking whether this resolved applies ("mappedHandlers" etc), so an implementation may simply proceed with its actual exception handling.

  Parameters:
    `request` - current HTTP request
    `response` - current HTTP response
    `handler` - the executed handler, or `null` if none chosen at the time of the exception (for example, if multipart resolution failed)
    `ex` - the exception that got thrown during handler execution
  Returns:
    a corresponding ModelAndView to forward to, or `null` for default processing

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD